Bug 690621 - Review TrueType hinting and patent expiration
Summary: Review TrueType hinting and patent expiration
Status: RESOLVED FIXED
Alias: None
Product: Ghostscript
Classification: Unclassified
Component: Graphics Library (show other bugs)
Version: master
Hardware: PC Windows NT
: P4 normal
Assignee: Ken Sharp
QA Contact: Bug traffic
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2009-07-11 00:33 UTC by Ken Sharp
Modified: 2010-07-21 09:07 UTC (History)
0 users

See Also:
Customer:
Word Size: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ken Sharp 2009-07-11 00:33:41 UTC
Some of the TrueType hinting patents expire in October 2009, we need to review
these patents and the existing Ghostscript TrueType rendering code to see if we
can now implement some or all of the missing instructions.

Review US patents 5155805, 5159668 and 5325479.
Comment 1 Ken Sharp 2009-11-17 00:36:33 UTC
Apple Patents covering TrueType
================================

Patent #1
Patent	        application	issued	        expires
==========================================================
US5155805	08-05-1989	13-10-1992	13-10-2009
GB2232861	27-04-1990			27-04-2010			
CA2015518	26-04-1990			26-04-2010
DE4014231	03-05-1990			03-05-1998

Patent #2
Patent	        application	issued	        expires
==========================================================
US5159668	08-05-1989	27-10-1992	27-10-2009
FR264729	07-05-1990			07-05-2010
JP3208094	08-05-1990			08-05-1995 to 08-05-2010

Patent #3
Patent	        application	granted	        expires
==========================================================
US5325479	28-05-1992	28-06-1994	13-10-2009 to 28-06-2011

Although the patent has a term of 17 years from grant (see below), the USPTO
site includes the notice "The portion of the term of this patent subsequent to
October 13, 2009 has been disclaimed" 


Arriving at the expiry dates
-----------------------------
The date of issue of a patent is only relevant in the US and for patents filed
before June 7th 1995, there was a change to US patent law on that date. Patents
filed before June 7th 1995 lasted for 17 years from the date of issue, patents
filed on or after that date last for 20 years from the application date.

All the US patents were filed before the cut-off date, and so are granted with a
lifetime of 17 years from the date of grant, or 20 years from the filing date of
the earliest US application, whichever is the longer. There may be applications
earlier than those published by the USPTO (though I doubt it) but that doesn't
matter for us, we just need to know the latest expiration.

Canadian patents have a term of 20 years from the date of filing, for patents
filed after October 1st 1989.

French patents run for 20 years from date of application.

German patents filed before 1st July 1990 run 18 years from date of application,
those filed on or after this date run 20 years from date of application.

UK patents are granted 20 years from the filing date.

Before 1st July 1995 the Japanese patent term is given as "15 years from the
date of examined publication but not in excess of 20 years from filing date".
After this date the term is 20 years from date of filing. Worst case for us is
20 years from date of filing.


I believe that 20 years from date of filing is now common practice to prevent
submarine patents. This appears to be the case for WTO (World Trade
Organisation) members and is known as the TRIPS agreement (Trade Related aspects
of Intellectual Property rights). The TRIPS agreement was signed in Marrakech on
15 April 1994.


I haven't been able to turn up any other specific patents covering this, a
patent lawyer with relevant experience and search tools might mange to do so,
these are the patents I was able to turn up using European search tools. 

However I think its reasonable to assume (given the filing dates) that patents
ourtside the US were applied for in the April/May period of 1990. All the major
non-US jurisdictions seem to have a maximum term of 20 years from date of
filing, so the patents should all have lapsed by the end of May 2010. (the
exception is US5325479 but that has apparently been disclaimed from October 2009
anyway)

We should be able to implement these instructions in the GS TrueType scaler in
time for the release anticipated in August 2010.
Comment 2 Ken Sharp 2010-07-21 09:07:21 UTC
FreeType now implements patented hinting, and this release of FreeType will be included in the next release of Ghostscript.

Given that this is intended to be a replacement for the Ghostscript TrueType font interpreter, there is no intention to add this facility, and no further work is required.